package MyQQServer;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.Socket;
import java.util.LinkedList;
import java.util.Map;
import java.util.Set;
import java.util.concurrent.Executors;
import java.util.concurrent.TimeUnit;

public class Server implements Runnable {
	// 
	private ServerArchives sa;

	// 
	private ObjectInputStream in = null;
	private ObjectOutputStream out = null;

	private Socket s;

	public Server(Socket s) {
		try {
			this.s = s;
			in = new ObjectInputStream(s.getInputStream());
			out = new ObjectOutputStream(s.getOutputStream());
		}
		catch (IOException e) {
			e.printStackTrace();
		}
		sa = ServerArchives.getInstance();
		doIt();
	}

	private void doIt() {
		// ʱϢ
		Executors.newSingleThreadScheduledExecutor().scheduleAtFixedRate(
				new Runnable() {
					public void run() {
						if (s == null)
							return;
						doMessage();
					}
				}, 1, 1, TimeUnit.SECONDS);
	}

	// Ϣб
	private LinkedList<Map<String, String>> list = new LinkedList<>();

	// ɾϢ
	public synchronized Map<String, String> deleteList() {
		if (list.size() > 0)
			return list.remove(0);
		return null;
	}

	// Ϣ
	public synchronized void addList(Map<String, String> map) {
		list.add(map);
	}

	// Ϣ
	public void run() {
		while (true) {
			try {
				@SuppressWarnings("unchecked")
				Map<String, String> m = (Map<String, String>) in.readObject();
				addList(m);
				ServerWindow.getInstance().setText("յϢ" + m.get("type"));
			}
			catch (Exception e) {
				break;
			}
		}
	}

	// Ϣ
	private void doMessage() {
		try {
			Map<String, String> map = deleteList();
			if (map == null)
				;
			else {
				String type = map.get("type");
				String sendId = map.get("sendId");
				String receiveId = map.get("receiveId");
				//String message = map.get("message");
				String name = map.get("name");
				String password = map.get("password");
				//String friends = map.get("friends");
				Map<String, User> users = sa.getUsers();
				Map<String, ObjectOutputStream> online = sa.getOnline();
				Map<String, LinkedList<Map<String, String>>> messages = sa
						.getMessages();

				// 
				switch (type) {
				case "register":
					String id = IDRandom.getInstance().getID();
					Message m = new Message();
					Map<String, String> zhuce = m.getRegisterMessages();
					m.setMessage("ok");
					m.setReceiveId(id);
					sendMessage(zhuce);

					// ûб
					User u = new User();
					u.setName(name);
					u.setPassword(password);
					sa.setUsers(id, u);
					break;

				case "login":
					User us = users.get(sendId);
					if (users.containsKey(sendId)
							&& password.equals(us.getPassword())) {
						Message success = new Message();
						Map<String, String> ma = success.getLoginMessages();
						success.setMessage("true");
						success.setName(name);
						success.setSendId(sendId);
						success.setFriends(us.getFriends());
						sendMessage(ma);
						sa.setOnline(sendId, out);

						// ǷϢ
						if (sa.getMessages().containsKey(sendId)) {
							ServerWindow.getInstance().setText("ǷԼ");
							LinkedList<Map<String, String>> list = messages
									.get(sendId);
							for (Map<String, String> mess : list)
								sendMessage(mess);
						}
					}
					else {
						Message fal = new Message();
						Map<String, String> ma = fal.getLoginMessages();
						fal.setMessage("false");
						sendMessage(ma);
					}
					break;

				case "over":
					sa.deleteOnline(sendId);
					in.close();
					out.close();
					break;

				case "message":
					ServerWindow.getInstance().setText("ͻڴmessage");
					// жĿǷ,߾ֱת
					online = sa.getOnline();
					if (online.containsKey(receiveId)) {
						ServerWindow.getInstance().setText("Ŀ");
						online.get(receiveId).writeObject(map);
					}

					// Ŀ겻,ȴ浵
					else {
						ServerWindow.getInstance().setText("Ŀ겻");
						sa.setMessages(receiveId, map);
					}
					break;

				case "find":
					Set<String> set = users.keySet();
					String temp = "";
					for(String s : set){
						temp+=s+"<s>";
					}
					System.out.println(temp);
					Message me = new Message();
					Map<String,String> ma = me.getFindMessages();
					me.setMessage(temp);
					sendMessage(ma);
				}
			}
		}
		catch (Exception e) {
			e.printStackTrace();
		}
	}

	// Ϣ
	public void sendMessage(Map<String, String> message) {
		try {
			out.writeObject(message);
		}
		catch (IOException e) {
			e.printStackTrace();
		}
	}
}
