package MyQQServer;

import java.awt.FlowLayout;
import java.awt.Label;
import java.awt.TextArea;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.IOException;
import java.net.InetAddress;
import java.net.ServerSocket;
import java.net.Socket;
import java.net.UnknownHostException;
import java.util.Map;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JTextField;

public class ServerWindow {
	private ServerWindow() {
	}

	private static ServerWindow server = new ServerWindow();

	public static ServerWindow getInstance() {
		return server;
	}

	
	//GUI
	JFrame f;
	
	private JLabel l1;
	private JTextField tf1;
	private JLabel l2;
	private JTextField tf2;

	private Label l3;
	private JButton b1;
	private JButton b2;
	
	private TextArea ta;

	private Map<String, String> loginMap;

	public Map<String, String> getMap() {
		return loginMap;
	}

	public void setMap(Map<String, String> map) {
		this.loginMap = map;
	}

	public void serverWindow() {
		f = new JFrame("˴");
		f.setBounds(500, 500, 200, 300);
		f.setLayout(new FlowLayout());

		l1 = new JLabel("  IP  ");
		tf1 = new JTextField(10);
		tf1.setText("127.0.0.1");
		f.add(l1);
		f.add(tf1);

		l2 = new JLabel("˿");
		tf2 = new JTextField(10);
		tf2.setText("10000");
		f.add(l2);
		f.add(tf2);

		b1 = new JButton("       ");
		b2 = new JButton("   Ͽ    ");
		f.add(b1);
		f.add(b2);
		
		l3=new Label("                                    ");
		f.add(l3);
		
		ta=new TextArea(8,22);
		f.add(ta);
		
		myEvent();
		f.setVisible(true);
		f.setResizable(false);
		b2.setVisible(false);
	}
	
	public void setText(String s){
		ta.append(s+"\r\n");
	}
	public void deleteText(){
		ta.setText("");
	}

	private void myEvent() {
		// 
		b1.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				// ˺
				String ip = tf1.getText();
				int port = Integer.parseInt(tf2.getText());
				set(ip, port);
				setFlag(true);
				l3.setText("    ɹ    ");
				tf1.setEditable(false);
				tf2.setEditable(false);
				b1.setVisible(false);
				b2.setVisible(true);
			}
		});

		// Ͽ
		b2.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				setFlag(false);
				l3.setText("    ѾϿ    ");
				tf1.setEditable(true);
				tf2.setEditable(true);
				b1.setVisible(true);
				b2.setVisible(false);
			}
		});

		// 
		f.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				System.exit(0);
			}
		});
	}
	
	
	//
	private  Socket s;
	private  ServerSocket ss;
	private  String ip;
	private  int port;
	private  boolean flag;

	private void set(String ip, int port) {
		this.ip = ip;
		this.port = port;
	}

	private boolean setFlag(boolean b) {
		if (b)
			try {
				ss = new ServerSocket(port,3, InetAddress.getByName(ip));
				show();
			}
			catch (UnknownHostException e) {
				e.printStackTrace();
			}
			catch (IOException e) {
				e.printStackTrace();
			}
		else
			try {
				ss.close();
			}
			catch (IOException e) {
				e.printStackTrace();
			}
		;
		return flag = b;
	}
	
	private void show(){
		new Thread(new Runnable(){
			public void run(){
				while (true) {
					if (flag)
						try {
							s = ss.accept();
							new Thread(new Server(s)).start();
						}
					catch (IOException e) {
						e.printStackTrace();
					}
					else
						try {
							Thread.sleep(1000);
						}
					catch (InterruptedException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
				}						
			}
		}).start();
	}
}
